// import SDK from './jslib/main.da57a581'
import SDK from './jslib/sdk/static/js/main';
import AccessToken from './AccessToken';

function subTem(name,bit) {
    return `
        <th class="name">${name}</th>
        <th><button type="button" class="btn btn-default subscribe">订阅</button></th>
        <th><button type="button" class="btn btn-default unsubscribe">取消订阅</button></th>
        <th><button type="button" class="btn btn-default subscribeChange">改变订阅</button></th>
        <th class="quality">${bit}</th>
    `
}

//获取当前分页所需的实例个数
function getCurPageDom() {
    let doms = $(".page");
    return $(doms)
}

//显示画面
function showVideo(sdkObj,doms,data,islocal){
    let keylist = null;
    console.log('拿到的流列表Key',keylist);
    
    let videos = null;

    if(islocal) {
        videos = doms.find('.sdk video').eq(5)[0];
        let span = doms.find('.sdk video').eq(5).prev();

        if(data.data && data.data.videoTrack) {
            let stream = new MediaStream();
            stream.addTrack(data.data.videoTrack)
            videos.srcObject = stream;
            videos.play();
            span.text("自己")
        }else{
            videos.srcObject = null;
            span.text("")
        }
    }else {
        keylist = Object.keys(data);
        let videos = doms.find('.sdk video');
        for(let i = 0; i < 5; i++) {
            let video =  videos.eq(i)[0];
            let span = videos.eq(i).prev();

            if(keylist[i] && $(video).attr('id') != data[keylist[i]].streamid) {
                let stream = new MediaStream();
                stream.addTrack(data[keylist[i]].track)
                video.srcObject = stream;
                video.play();
                $(video).attr('id',data[keylist[i]].streamid);;
                
                let mt = sdkObj.data.mtMap.get(data[keylist[i]].mtid + "");
                let name = mt.name ? (mt.name+" "+mt.e164) : mt.e164;
                span.text(name)
            }
            if(keylist[i] == null) {
                video.srcObject = null;
                $(video).attr('id','')
                span.text('');
            }
        }
    }

    
}

//设置音频输入
function setDevice(doms,sdkObj,type,data) {
    let cur = '';
    let list = [];

    sdkObj.data['cur'+type] ? cur = sdkObj.data['cur'+type] : sdkObj.data['cur'+type] = '';
    sdkObj.data['list'+type] ? list = sdkObj.data['list'+type] : sdkObj.data['list'+type] = '';

    (data && data.cur && data.cur != '') ? cur = data.cur : '';
    (data && data.list) ? list = data.list : '';

    sdkObj.data['cur'+type] = cur; sdkObj.data['list'+type] = list; 

    let curName = '';
    let typeNme = '';
    switch (type){
        case 'audioInput':
            typeNme = '音频输入'; break;
        case 'videoInput':
            typeNme = '视频输入'; break;
        case 'audioOutput':
            typeNme = '音频输出'; break;
        default:
            console.log("may be error")
    }

    doms.find('.control .'+type+' ul').html(''); 
    if(list.length > 0) {
        for(let i = 0; i < list.length; i++) {
            if(cur != '' && cur == list[i].deviceId) {
                curName = list[i].label
            }
            let li = $('<li><a id="' + list[i].deviceId + '">' + list[i].label + '</a></li>');
            doms.find('.control .'+type+' ul').append(li)
        }
    }

    if(curName != '') {
        doms.find('.control .'+type+' button').html(curName+'<span class="caret"></span>')
        doms.find('.control .'+type+' button').attr("title",curName);
    }else {
        doms.find('.control .'+type+' button').html('请选择设备<span class="caret"></span>')
        doms.find('.control .'+type+' button').attr("title","请选择"+typeNme+"设备");
    }

}

//监听sdk事件
function bindSdkEvent(doms,sdkObj) {
    sdkObj.sdk.on('mtlistPeersUpdate',(data) => {//订阅列表更新
        sdkObj.data.subarr ? "" : sdkObj.data.subarr = [];
        sdkObj.data.mtMap ? "" : sdkObj.data.mtMap = new Map();
        let curArr = [];
        for(let i in data) {
            curArr.push(data[i].e164);
            if(!sdkObj.data.subarr.includes(data[i].e164)){
                sdkObj.data.subarr.push(data[i].e164);
                sdkObj.data.mtMap.set(data[i].mtId,data[i])
                let ts = document.createElement('tr');
                ts.innerHTML = subTem(data[i].e164,"low");
                $("#tbody").append($(ts));
            }
        }
        let names = $('#tbody .name');
        for(let j = 0; j <names.length; j++) {
            let node = $(names[j]).text();
            if(!curArr.includes(node)){
                $(names[j]).parents('tr').remove();
            }
        }
        sdkObj.data.subarr = curArr;
    })
    sdkObj.sdk.on('meAudioinputDevicesUpdate',(data) => {//音频输入更新
        console.log("meAudioinputDevicesUpdate",data)
        setDevice(doms,sdkObj,'audioInput',{list: data})
    })
    sdkObj.sdk.on('meVideoinputDevicesUpdate',(data) => {//视频输入更新
        console.log("meVideoinputDevicesUpdate",data)
        setDevice(doms,sdkObj,'videoInput',{list: data})
    })
    sdkObj.sdk.on('meAudiooutputDevicesUpdate',(data) => {//音频输出更新
        console.log("meAudiooutputDevicesUpdate",data)
        setDevice(doms,sdkObj,'audioOutput',{list: data})
    })
    sdkObj.sdk.on('meCurrentAudioinputDeviceIdUpdate',(data) => {//当前音频输入更新
        console.log("meCurrentAudioinputDeviceIdUpdate",data)
        setDevice(doms,sdkObj,'audioInput',{cur: data})
    })
    sdkObj.sdk.on('meCurrentVideoinputDeviceIdUpdate',(data) => {//当前视频输入更新
        console.log("meCurrentVideoinputDeviceIdUpdate",data)
        setDevice(doms,sdkObj,'videoInput',{cur: data})
    })
    sdkObj.sdk.on('meCurrentAudiooutputDeviceIdUpdate',(data) => {//当前音频输出更新
        console.log("meCurrentAudiooutputDeviceIdUpdate",data)
        setDevice(doms,sdkObj,'audioOutput',{cur: data})
    })
    sdkObj.sdk.on('mediasConsumersUpdate',(data) => {//视频流更新
        console.log("mediasConsumersUpdate",data)
        showVideo(sdkObj,doms,data)
    })
    sdkObj.sdk.on('localVideoTrackUpdate',(data) => {//本地视频流更新
        console.log("localVideoTrackUpdate",data)
        showVideo(sdkObj,doms,data,true)
    })
}

//初始化主动触发事件
function initButton(doms,sdkObj) {
    /*
    *初始化配置
    */ 
    //初始化
    doms.find(".control .init").on('click',function(){
        let hostname = $('#hostname').val();
        
        sdkObj.sdk.init({
            hostname: hostname,
            isKrtcLogin: true,
            success: function(){
                console.log('-----------初始化成功-----------')
                doms.find('.btn').removeAttr('disabled')
            },
            error: function(){
                doms.find('.btn').removeAttr('disabled')
            }
            // error: function(){
            //     sdkObj.sdk.autoLogin({
            //         nickname: 'test',
            //         hostname: hostname,
            //         success: function(){
            //             console.log('-----------初始化成功-----------')
            //             doms.find('.btn').removeAttr('disabled')
            //             sdkObj.sdk.enableCamera()
            //         },
            //         error: function(){
            //             console.log('-----------初始化失败-----------')
            //         }
            //     })
            // }
        })
    })
    /*
    *全局接口
    */
    //获取SDK版本号
    doms.find(".control .getVersion").on('click',function(){
        console.log('-----------获取SDK版本号-----------')
        console.log(sdkObj.sdk.getVersion())
    })
    //获取可用的SDK实例ID列表
    doms.find(".control .getClientIds").on('click',function(){
        console.log('-----------获取可用的SDK实例ID列表-----------')
        console.log(SDK.getClientIds())
    })
    /*
    *数据接口
    */
   //获取SDK实例缓存会议ID
    doms.find(".control .getRoomId").on('click',function(){
        console.log('-----------获取SDK实例缓存会议ID-----------')
        console.log(sdkObj.sdk.getRoomId())
    })
    //获取SDK实例缓存用户昵称
    doms.find(".control .getNickname").on('click',function(){
        console.log('-----------获取SDK实例缓存用户昵称-----------')
        console.log(sdkObj.sdk.getNickname())
    })
    //获取用户ID
    doms.find(".control .getUserId").on('click',function(){
        console.log('-----------获取用户ID-----------')
        console.log(sdkObj.sdk.getUserId())
    })
    //获取Room信息
    doms.find(".control .getRoomInfo").on('click',function(){
        console.log('-----------获取Room信息-----------')
        console.log(sdkObj.sdk.getRoomInfo())
    })
    //获取Room用户列表
    doms.find(".control .getUserList").on('click',function(){
        console.log('-----------获取Room用户列表-----------')
        console.log(sdkObj.sdk.getUserList())
    })
    /*
    *基础接口
    */  
    //登录
    doms.find('.control .login').on('click', function(e){
        //免登陆
        let userId = $('#userId').val();
        let hostname = $('#hostname').val();
        let nickname = $('#nickname').val();

        let appToken = new AccessToken().build(userId,1000*60);
        window.aa = new AccessToken();


        if(userId && userId != '' ) {
            $('.baseNeed').hide()
        }else {
            $('.baseNeed').show().text('登录需要账号')
            return;
        }

        let parme = {
            userId: userId,
            appToken: appToken,
            autoSubAllVideoStream: true,
            nickname: nickname,
            hostname: hostname,
            success: function(){
                console.log('-----------登录成功-----------')
            },
            error: function(){
                console.log('-----------登录失败-----------')
            }
        }
        sdkObj.sdk.krtcLogin(parme)
    })
    //免登录
    // doms.find('.control .autologin').on('click', function(e){
    //     let hostname = $('#hostname').val();

    //     sdkObj.sdk.autoLogin({
    //         nickname: 'test',
    //         hostname: hostname,
    //         success: function(){
    //             console.log('-----------免登录成功-----------')
    //             sdkObj.sdk.enableCamera()
    //         },
    //         error: function(){
    //             console.log('-----------免登录失败-----------')
    //         }
    //     })
    // })
    
    //入会
    doms.find('.control .join').on('click', function(e){
        let meetingId = $('#meetingId').val();
        if(meetingId && meetingId != '') {
            $('.baseNeed').hide()
        }else {
            $('.baseNeed').show().text('入会需要meetingId')
            return;
        }
        sdkObj.sdk.join({
            roomId: meetingId,
            success: function(){
                console.log('-----------入会成功-----------')
                sdkObj.sdk.enableCamera()
            },
            error: function(){
                console.log('-----------入会失败-----------')
            }
        })
    })
    //退会
    doms.find('.control .exit').on('click', function(e){
        sdkObj.sdk.exit({
            success: function(){
                console.log('-----------退会成功-----------')
            },
            error: function(){
                console.log('-----------退会失败-----------')
            }
        })
    })
    /*
    *订阅相关接口
    */ 
    //订阅
    doms.find('.control').on('click','.subscribe', function(e){
        let mtid = $(e.target).parents('tr').find('.name').text();
        sdkObj.data.quality = 'low';
        sdkObj.data.subscribeMt = mtid;
        sdkObj.sdk.subscribe({
            userId: mtid,
            dual: false,
            quality: "low",
            success: function(){
                console.log('-----------订阅终端'+mtid+'成功-----------')
            },
            error: function(){
                console.log('-----------订阅终端'+mtid+'失败-----------')
            }
        })
    })
    //改变订阅
    doms.find('.control').on('click','.subscribeChange', function(e){
        let mtid = $(e.target).parents('tr').find('.name').text();
        let quality = $(e.target).parents('tr').find('.quality').text();
        if(quality == 'low'){
            $(e.target).parents('tr').find('.quality').text('high');
            quality = 'high';
        }else {
            $(e.target).parents('tr').find('.quality').text('low');
            quality = 'low';
        }
        sdkObj.sdk.subscribeChange({
            userId: mtid,
            dual: false,
            quality: quality,
            success: function(){
                console.log('-----------改变订阅分辨率成功-----------')
            },
            error: function(){
                console.log('-----------改变订阅分辨率失败-----------')
            }
        })
    })
    //取消订阅
    doms.find('.control').on('click','.unsubscribe', function(e){
        let mtid = $(e.target).parents('tr').find('.name').text();
        sdkObj.sdk.unsubscribe({
            userId: mtid,
            dual: false,
            success: function(){
                console.log('-----------取消订阅终端'+sdkObj.data.subscribeMt+'成功-----------')
            },
            error: function(){
                console.log('-----------取消订阅终端'+sdkObj.data.subscribeMt+'失败-----------')
            }
        })
    })
    /*
    *麦克风相关接口
    */ 
    //获取麦克风列表
    doms.find(".control .listMicrophone").on('click',function(){
        console.log('-----------获取麦克风列表-----------')
        console.log(sdkObj.sdk.listMicrophone())
    })
    //开启麦克风
    doms.find(".control .enableMicrophone").on('click',function(){
        console.log('-----------开启麦克风-----------')
        console.log(sdkObj.sdk.enableMicrophone())
    })
    //关闭麦克风
    doms.find(".control .disableMicrophone").on('click',function(){
        console.log('-----------关闭麦克风-----------')
        console.log(sdkObj.sdk.disableMicrophone())
    })
    //测试麦克风
    doms.find(".control .testMicrophone").on('click',function(){
        console.log('-----------测试麦克风-----------')
        console.log(sdkObj.sdk.testMicrophone())
    })
    //获取麦克风测试音量
    doms.find(".control .testMicrophoneVolume").on('click',function(){
        console.log('-----------获取麦克风测试音量-----------')
        console.log(sdkObj.sdk.testMicrophoneVolume())
    })
    /*
    *摄像头相关接口
    */ 
    //获取摄像头列表
    doms.find(".control .listCamera").on('click',function(){
        console.log('-----------获取摄像头列表-----------')
        console.log(sdkObj.sdk.listCamera())
    })
    //开启摄像头
    doms.find(".control .enableCamera").on('click',function(){
        console.log('-----------开启摄像头-----------')
        console.log(sdkObj.sdk.enableCamera())
    })
    //关闭摄像头
    doms.find(".control .disableCamera").on('click',function(){
        console.log('-----------关闭摄像头-----------')
        console.log(sdkObj.sdk.disableCamera())
    })
    /*
    *扬声器相关接口
    */ 
    //获取扬声器列表
    doms.find(".control .listLoudspeaker").on('click',function(){
        console.log('-----------获取扬声器列表-----------')
        console.log(sdkObj.sdk.listLoudspeaker())
    })
    //开启扬声器
    doms.find(".control .enableLoudspeaker").on('click',function(){
        console.log('-----------开启扬声器-----------')
        console.log(sdkObj.sdk.enableLoudspeaker())
    })
    //关闭扬声器
    doms.find(".control .disableLoudspeaker").on('click',function(){
        console.log('-----------关闭扬声器-----------')
        console.log(sdkObj.sdk.disableLoudspeaker())
    })
    /*
    *共享相关接口
    */ 
    //开启共享屏幕
    doms.find(".control .enableShare").on('click',function(){
        console.log('-----------开启共享屏幕-----------')
        console.log(sdkObj.sdk.enableShare())
    })
    //开启扬声器
    doms.find(".control .disableShare").on('click',function(){
        console.log('-----------关闭共享屏幕-----------')
        console.log(sdkObj.sdk.disableShare())
    })
    

    //设备切换事件
    doms.find('.control .audioInput .dropdown-menu').on('click', 'li', function(e){
        let deviceid = $(e.target).attr('id');
        console.log("切换设备ID",deviceid)
        sdkObj.sdk.changeMicrophone({
            deviceId: deviceid
        })
    })
    doms.find('.control .audioOutput .dropdown-menu').on('click', 'li', function(e){
        let deviceid = $(e.target).attr('id');
        console.log("切换设备ID",deviceid)
        sdkObj.sdk.changeLoudspeaker({
            deviceId: deviceid
        })
    })
    doms.find('.control .videoInput .dropdown-menu').on('click', 'li', function(e){
        let deviceid = $(e.target).attr('id');
        console.log("切换设备ID",deviceid)
        sdkObj.sdk.changeCamera({
            deviceId: deviceid
        })
    })
}

//初始化
export function init() {
    let doms = getCurPageDom()
    var sdkObj = {};
    //获取复用ID
    let idArr = SDK.getClientIds();
    //创建SDK数组
    if(idArr.length > 0) {
        sdkObj = {sdk: new SDK({clientId: idArr[0]}),data:{}}
    }else {
        sdkObj = {sdk: new SDK(),data:{}}
    }
    window.sdkObj = sdkObj;
    
    bindSdkEvent(doms,sdkObj)
    initButton(doms,sdkObj)
    doms.find('.btn').attr('disabled','disabled')
    doms.find('.init').removeAttr('disabled')
}